--- /usr/src/sys/kern/kern_mutex.c	Thu May 10 19:07:02 2007
+++ kern_mutex.c	Tue May 15 19:39:32 2007
@@ -275,6 +275,9 @@
 	    file, line));
 
 	if (mtx_owned(m) && (m->lock_object.lo_flags & LO_RECURSABLE) != 0) {
+		if (LOCK_LOG_TEST(&m->lock_object, opts))
+			CTR3(KTR_LOCK, "_mtx_trylock: %p recursing @ %s:%d", m,
+			    file, line);
 		m->mtx_recurse++;
 		atomic_set_ptr(&m->mtx_lock, MTX_RECURSED);
 		rval = 1;
@@ -322,7 +325,8 @@
 		m->mtx_recurse++;
 		atomic_set_ptr(&m->mtx_lock, MTX_RECURSED);
 		if (LOCK_LOG_TEST(&m->lock_object, opts))
-			CTR1(KTR_LOCK, "_mtx_lock_sleep: %p recursing", m);
+			CTR3(KTR_LOCK, "_mtx_lock_sleep: %p recursing @ %s:%d",
+			    m, file, line);
 		return;
 	}
 
@@ -504,7 +508,8 @@
 		if (--(m->mtx_recurse) == 0)
 			atomic_clear_ptr(&m->mtx_lock, MTX_RECURSED);
 		if (LOCK_LOG_TEST(&m->lock_object, opts))
-			CTR1(KTR_LOCK, "_mtx_unlock_sleep: %p unrecurse", m);
+			CTR3(KTR_LOCK, "_mtx_unlock_sleep: %p unrecurse @ "
+			    "%s:%d", m, file, line);
 		return;
 	}
 
